# LDAP Account Manager

# lib/html.inc

# Properties

author
package

## Description

Interface between modules and other parts of LAM.

## Classes

### htmlElement

# Properties

Extends
Implements
package
metaHTML
Abstract
Yes
Final
No

#### Description

Represents a HTML element.
This is used to build HTML code by using objects.

#### Methods

generateHTML, getAlignmentString, getColspanString, getRowspanString, getTableCellCSSClasses, setCSSClasses, setTableCellCSSClasses,

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### getAlignmentString( ) : String

#### Description

Returns the HTML attributes for the alignment.

#### Return value

Type | Description
--- | ---
String | alignment HTML attributes (e.g. align=&quot;right&quot; valign=&quot;top&quot;)

### getColspanString( ) : String

#### Description

Returns the HTML attribute for the colspan.

#### Return value

Type | Description
--- | ---
String | colspan HTML attribute (e.g. colspan=3)

### getRowspanString( ) : String

#### Description

Returns the HTML attribute for the rowspan.

#### Return value

Type | Description
--- | ---
String | rowspan HTML attribute (e.g. rowspan=3)

### getTableCellCSSClasses( ) : array

#### Description

Returns the CSS classes of the surrounding table cell for this element.

#### Return value

Type | Description
--- | ---
array | CSS classes

### setCSSClasses( array $classes, ) : n/a

#### Description

Adds CSS classes to this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$classes | array | CSS class names |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTableCellCSSClasses( array $classes, ) : n/a

#### Description

Adds CSS classes to the surrounding table cell for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$classes | array | CSS class names |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$alignment, $colspan, $cssClasses, $rowspan, $tableCellCssClasses,

### public $alignment = null

alignment when inside a table

### public $colspan = null

colspan if inside a table

### protected $cssClasses = array()

CSS classes

### public $rowspan = null

rowspan if inside a table

### protected $tableCellCssClasses = array()

table cell CSS classes

#### Constants

### ALIGN_BOTTOM = 3

align to bottom

### ALIGN_CENTER = 4

align to center

### ALIGN_LEFT = 1

align to left

### ALIGN_RIGHT = 2

align to right

### ALIGN_TOP = 0

align to top

### VALIDATE_NUMERIC = 'numeric'

validation rule to allow only numbers ([0-9]+)

### VALIDATE_NUMERIC_WITH_NEGATIVE = 'numericWithNegative'

validation rule to allow positive/negative numbers ([-]?[0-9]+)

### htmlTable

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Structures elements using a table.
This is used to build HTML code by using objects.

#### Methods

__construct, addElement, addNewLine, generateHTML, mergeTableElements,

### __construct( String $width = null, $id = null, ) : n/a

#### Description

Constructor

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$width | String | table width (e.g. 100%) | null
$id | n/a |  | null

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |

### addElement( mixed $element, boolean $newLine = false, boolean $isTableHeadElement = false, ) : n/a

#### Description

Adds an element to the table. The element may be a htmlElement object or a simple String.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$element | mixed | htmlElement object or a simple String |
$newLine | boolean | adds a new line after the element (optional, default false) | false
$isTableHeadElement | boolean | specifies if this is a head or body element (default: body) | false

#### Return value

Type | Description
--- | ---
n/a | n/a

### addNewLine( ) : n/a

#### Description

Adds another line to the table.

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### mergeTableElements( $table, ) : n/a

#### Description

Merges the content of another htmlTable object into this table.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$table | n/a | table to get elements |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$elements, $id, $rowOpen, $width,

### private $elements = array()

list of subelements

### private $id = null

HTML ID

### private $rowOpen = false

specifies if currently a row is open

### private $width = null

table width

#### Constants

### footer = "</table>\n"

table footer

### newLine = "</tr><tr>\n"

new line

### htmlTableRow

# Properties

Extends
Implements
package
metaHTML
see
Abstract
No
Final
No

#### Description

A row inside a htmlTable.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( array $cells, ) : n/a

#### Description

Constructor

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$cells | array | list of htmlElements |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$cells,

### private $cells =

table cells

### htmlInputField

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

A standard input field.
This is used to build HTML code by using objects.

#### Methods

__construct, enableAutocompletion, generateHTML, setFieldMaxLength, setFieldSize, setIsEnabled, setIsPassword, setObfuscate, setOnKeyPress, setRequired, setTitle, setTransient, setValidationRule, showCalendar,

### __construct( String $fieldName, String $fieldValue = null, String $fieldSize = null, ) : n/a

#### Description

Constructor

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$fieldName | String | unique field name |
$fieldValue | String | value of input field (optional) | null
$fieldSize | String | maximum input length | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### enableAutocompletion( array $values, int $minLength = 1, boolean $multiValue = false, $multiSeparatorExp = ',\s*', String|String $multiSeparator = ', ', ) : n/a

#### Description

Enables autocompletion for this input field.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$values | array | list of values to suggest |
$minLength | int | autocompletion starts after this number of caracters entered (default 1; 0 means immediate start) | 1
$multiValue | boolean | allow multiple autocompletion values in the same fields (default: false) | false
$multiSeparatorExp | n/a |  | ',\s*'
$multiSeparator | String|String | separator expression if multiple autocompletion values are allowed (default ",\s*") | ', '

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setFieldMaxLength( int $fieldMaxLength, ) : n/a

#### Description

Sets the maximum field length.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$fieldMaxLength | int | length |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setFieldSize( int $fieldSize, ) : n/a

#### Description

Sets the field size.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$fieldSize | int | size |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setIsEnabled( boolean $isEnabled, ) : n/a

#### Description

Specifies if this component is enabled and accepts user modification.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isEnabled | boolean | enabled if true |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setIsPassword( boolean $isPassword, ) : n/a

#### Description

Specifies if this is a password field.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isPassword | boolean | password field |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setObfuscate( boolean $obfuscate, ) : n/a

#### Description

Specifies if the value should be saved in obfuscated form (e.g. self service profile).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$obfuscate | boolean | obfuscate value |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setOnKeyPress( String $onKeyPress, ) : n/a

#### Description

Sets the JavaScript for the onKeyPress event.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$onKeyPress | String | JavaScript code |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setRequired( boolean $required, ) : n/a

#### Description

Specifies if the input field is required.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$required | boolean | required |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTitle( String $title, ) : n/a

#### Description

Sets the title for the input field.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$title | String | title value |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTransient( boolean $transient, ) : n/a

#### Description

Specifies that the value should not be automatically saved when used in self service or server profile (default: false).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$transient | boolean | transient field |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setValidationRule( boolean $rule, ) : n/a

#### Description

Specifies the validation rule (e.g. htmlElement::VALIDATE_NUMERIC) for this field.
This rule is checked on client side when the input field looses focus.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$rule | boolean | rule name |

#### Return value

Type | Description
--- | ---
n/a | n/a

### showCalendar( String $format, ) : n/a

#### Description

Shows a calendar when the field is selected.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$format | String | calendar format (e.g. yyyy-mm-dd) |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$autocomplete, $autocompleteMinLength, $autocompleteMultiValue, $autocompleteMultiValueSeparator, $autocompleteMultiValueSeparatorExp, $autocompleteValues, $calendarFormat, $fieldMaxLength, $fieldName, $fieldSize, $fieldValue, $isEnabled, $isPassword, $obfuscate, $onKeyPress, $required, $showCalendar, $title, $transient, $validationRule,

### protected $autocomplete = false

enable autocomplete

### protected $autocompleteMinLength = 1

autocomplete start at this input length

### protected $autocompleteMultiValue = false

multiple values in one field

### protected $autocompleteMultiValueSeparator = null

separator for multiple values in one field

### protected $autocompleteMultiValueSeparatorExp = null

separator expression for multiple values in one field

### protected $autocompleteValues = array()

autocompletion suggestions

### protected $calendarFormat = ''

calendar format

### protected $fieldMaxLength = 255

field max length (default 255)

### protected $fieldName =

unique field name

### protected $fieldSize = 30

field size (default 30)

### protected $fieldValue =

field value

### protected $isEnabled = true

enabled or disabled

### protected $isPassword = false

password field

### protected $obfuscate = false

indicates that the value should be saved in obfuscated form

### protected $onKeyPress = null

on keypress event

### protected $required = false

required field

### protected $showCalendar = false

show calendar

### protected $title = null

title attribute

### protected $transient = false

indicates that this field should not automatically be saved in the self service or server profile

### protected $validationRule = null

validation rule

### htmlTableExtendedInputField

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

An extended input field that combines label, input field and help.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $label, String $fieldName, String $fieldValue = null, String $helpID = null, ) : n/a

#### Description

Constructor

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$label | String | descriptive label |
$fieldName | String | unique field name |
$fieldValue | String | value of input field (optional) | null
$helpID | String | help ID (optional) | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$helpID, $label,

### private $helpID =

help ID

### private $label =

Descriptive label

### htmlHelpLink

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Renders a help link.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $helpID, String $module = null, String $scope = null, ) : n/a

#### Description

Constructor

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$helpID | String | help ID |
$module | String | module name (optional, only if value from generateHTML() should be overwritten) | null
$scope | String | account type (e.g. user) (optional, only if value from generateHTML() should be overwritten) | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$helpID, $module, $scope,

### private $helpID =

help ID

### private $module =

module name if it should be forced

### private $scope =

account type if it should be forced

### htmlButton

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Simple button.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, setIconClass, setIsEnabled, setOnClick, setTitle,

### __construct( String $name, String $value, String $isImageButton = false, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | button name |
$value | String | button text or image (16x16px, relative to graphics folder) |
$isImageButton | String | image or text button (default text) | false

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setIconClass( String $iconClass, ) : n/a

#### Description

Sets an additional icon for a text button.
The icon class is a CSS class that specifies the icon image (e.g. "deleteButton" in layout.css).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$iconClass | String | icon class |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setIsEnabled( boolean $isEnabled, ) : n/a

#### Description

Specifies if this component is enabled and accepts user modification.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isEnabled | boolean | enabled if true |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setOnClick( String $onClick, ) : n/a

#### Description

Sets the onclick event code.
This makes this button a simple button that does not submit a form.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$onClick | String | JS code |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTitle( String $title, ) : n/a

#### Description

Sets the button title (tooltip).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$title | String | title |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$iconClass, $isEnabled, $isImageButton, $name, $onClick, $title, $value,

### private $iconClass = null

icon class (CSS) for buttons with icon + text

### private $isEnabled = true

enabled or disabled

### protected $isImageButton =

image button or text button

### protected $name =

button name

### private $onClick = null

onclick event

### private $title = null

title

### protected $value =

button text or image

### htmlAccountPageButton

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Prints a button for the account pages.
This is used to build HTML code by using objects.

#### Methods

__construct,

### __construct( String $targetModule, String $targetPage, String $identifier, String $value, String $isImageButton = false, ) : n/a

#### Description

Constructor

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$targetModule | String | module name which renders next page |
$targetPage | String | name of next page |
$identifier | String | identifier for button |
$value | String | button text or image (16x16px, relative to graphics folder) |
$isImageButton | String | image or text button (default text) | false

#### Return value

Type | Description
--- | ---
n/a | n/a

### htmlSelect

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Represents a select box.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, printCodeForShowHideTableRows, printOptionsHTML, setContainsOptgroups, setHasDescriptiveElements, setIsEnabled, setMultiSelect, setOnchangeEvent, setRightToLeftTextDirection, setSortElements, setTableRowsToHide, setTableRowsToShow, setTransformSingleSelect, setTransient, setWidth,

### __construct( String $name, array $elements, array $selectedElements = array(), int $size = 1, ) : n/a

#### Description

Constructor.
Examples:
$select = new htmlSelect('myName', array('value1', 'value2'), array('value1'));
$select = new htmlSelect('myName', array('label1' => 'value1', 'label2' => 'value2'), array('value1'));
$select->setHasDescriptiveElements(true);
$select = new htmlSelect('myName', array('optgroupLabel' => array('value1', 'value2')), array('value1'));
$select->setHasDescriptiveElements(true);
$select->setContainsOptgroups(true);

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | element name |
$elements | array | list of elements array(label => value) or array(value1, value2) or array('optgroup' => array(...)) |
$selectedElements | array | list of selected elements (optional, default none) | array()
$size | int | size (optional, default = 1) | 1

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### printCodeForShowHideTableRows( String $onChange, ) : n/a

#### Description

Creates the JavaScript code to hide/show table rows based on the select value.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$onChange | String | onChange code |

#### Return value

Type | Description
--- | ---
n/a | n/a

### printOptionsHTML( array $elements, ) : n/a

#### Description

Prints the HTML code of the option tags.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$elements | array | list of options |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setContainsOptgroups( boolean $containsOptgroups, ) : n/a

#### Description

Specifies if the elements are divided into optgroups.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$containsOptgroups | boolean | activates optgroups |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setHasDescriptiveElements( boolean $hasDescriptiveElements, ) : n/a

#### Description

Specifies if the elements are just a simple list or an assoziative array (default: simple list).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$hasDescriptiveElements | boolean | activates descriptive elements |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setIsEnabled( boolean $isEnabled, ) : n/a

#### Description

Specifies if this component is enabled and accepts user modification.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isEnabled | boolean | enabled if true |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setMultiSelect( boolean $multiSelect, ) : n/a

#### Description

Specifies if multi-selection is enabled (default: disabled).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$multiSelect | boolean | allows multi-selection |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setOnchangeEvent( String $onchangeEvent, ) : n/a

#### Description

Sets the JavaScript code for the onchange event.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$onchangeEvent | String | onchange event code (e.g. myfunction();) |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setRightToLeftTextDirection( boolean $rightToLeftTextDirection, ) : n/a

#### Description

Specifies if the text direction should be set to right to left.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$rightToLeftTextDirection | boolean | if true use right to left direction |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setSortElements( boolean $sortElements, ) : n/a

#### Description

Specifies if the elemets should be sorted (default: sort).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$sortElements | boolean | sort elements |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTableRowsToHide( array $tableRowsToHide, ) : n/a

#### Description

This will hide the given table rows when the select is changed to the specified value.
The given IDs can be of any e.g. input element. Starting from this element the first parent "
" element will be used to show/hide.
Example:
Using "mycheckbox" will use this "tr" to hide/show.
Example for $tableRowsToHide:
array('yes' => array('option1', 'option2'), 'no' => array('option3'))

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$tableRowsToHide | array | array of select value => array of IDs of child elements to hide |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTableRowsToShow( array $tableRowsToShow, ) : n/a

#### Description

This will show the given table rows when the select is changed to the specified value.
The given IDs can be of any e.g. input element. Starting from this element the first parent "
" element will be used to show/hide.
Example:
Using "mycheckbox" will use this "tr" to hide/show.
Example for $tableRowsToShow:
array('yes' => array('option1', 'option2'), 'no' => array('option3'))

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$tableRowsToShow | array | array of select value => array of IDs of child elements to show |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTransformSingleSelect( boolean $transformSingleSelect, ) : n/a

#### Description

Specifies if select boxes that contain only a single element should be transformed to a simple text field.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$transformSingleSelect | boolean | transform single options to text |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTransient( boolean $transient, ) : n/a

#### Description

Specifies that the value should not be automatically saved when used in self service or server profile (default: false).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$transient | boolean | transient field |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setWidth( String $width, ) : n/a

#### Description

Specifies the width of this selection box.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$width | String | width (e.g. 20em) |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$containsOptgroups, $elements, $hasDescriptiveElements, $isEnabled, $multiSelect, $name, $onchangeEvent, $rightToLeftTextDirection, $selectedElements, $size, $sortElements, $tableRowsToHide, $tableRowsToShow, $transformSingleSelect, $transient, $width,

### private $containsOptgroups = false

contains optgroups

### private $elements =

elements

### private $hasDescriptiveElements = false

descriptive elements

### private $isEnabled = true

enabled or disabled

### private $multiSelect = false

allows multi-selection

### private $name =

name of select field

### private $onchangeEvent = null

onchange event

### private $rightToLeftTextDirection = false

right to left text direction

### private $selectedElements = array()

selected elements

### private $size =

size

### private $sortElements = true

sorting enabled

### protected $tableRowsToHide = array()

list of enclosing table rows to hide when checked

### protected $tableRowsToShow = array()

list of enclosing table rows to show when checked

### private $transformSingleSelect = true

transform select boxes with one element to text

### private $transient = false

indicates that this field should not automatically be saved in the self service or server profile

### private $width = ''

width of input element

### htmlTableExtendedSelect

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Select with label and help link.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $name, array $elements, array $selectedElements, String $label, String $helpID = null, int $size = 1, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | element name |
$elements | array | list of elememts |
$selectedElements | array | list of selected elements |
$label | String | descriptive label |
$helpID | String | help ID (optional, default none) | null
$size | int | size (optional, default = 1) | 1

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$helpID, $label,

### private $helpID =

help ID

### private $label =

descriptive label

### htmlRadio

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Represents a radio selection.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, setIsEnabled, setOnchangeEvent,

### __construct( String $name, array $elements, String $selectedElement = null, ) : n/a

#### Description

Constructor.
Examples:
$radio = new htmlRadio('myName', array('label1' => 'value1', 'label2' => 'value2'), array('value1'));

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | element name |
$elements | array | list of elements array(label => value) |
$selectedElement | String | value of selected element (optional, default none) | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setIsEnabled( boolean $isEnabled, ) : n/a

#### Description

Specifies if this component is enabled and accepts user modification.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isEnabled | boolean | enabled if true |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setOnchangeEvent( String $onchangeEvent, ) : n/a

#### Description

Sets the JavaScript code for the onchange event.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$onchangeEvent | String | onchange event code (e.g. myfunction();) |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$elements, $isEnabled, $name, $onchangeEvent, $selectedElement,

### private $elements =

elements

### private $isEnabled = true

enabled or disabled

### private $name =

name of select field

### private $onchangeEvent = null

on change code

### private $selectedElement = null

selected element

### htmlTableExtendedRadio

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Radio list with descriptive label and help link.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $label, String $name, array $elements, String $selectedElement = null, String $helpID = null, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$label | String | descriptive label |
$name | String | element name |
$elements | array | list of elements array(label => value) |
$selectedElement | String | value of selected element (optional, default none) | null
$helpID | String | help ID | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$helpID, $label,

### private $helpID =

help ID

### private $label =

descriptive label

### htmlOutputText

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Prints the text and escapes contained HTML code by default.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, setIsBold, setMarkAsRequired, setNoWrap,

### __construct( String $string, boolean $escapeHTML = true, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$string | String | output text |
$escapeHTML | boolean | escape HTML code (default yes) | true

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setIsBold( boolean $isBold, ) : n/a

#### Description

Specifies if the whole text should be printed in bold.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isBold | boolean | bold text |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setMarkAsRequired( boolean $markAsRequired, ) : n/a

#### Description

Adds a marker that indicates a required field.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$markAsRequired | boolean | add marker |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setNoWrap( boolean $noWrap, ) : n/a

#### Description

Specifies if word wrap is allowed for this text.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$noWrap | boolean | no wrapping if set to true (default false) |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$escapeHTML, $isBold, $markAsRequired, $noWrap, $string,

### private $escapeHTML =

specifies if HTML code should be escaped

### private $isBold = false

bold text

### private $markAsRequired = false

mark as required

### private $noWrap = false

no wrap

### private $string =

the text to print

### htmlInputCheckbox

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Prints the HTML code for a checkbox.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, setIsEnabled, setTableRowsToHide, setTableRowsToShow, setTransient,

### __construct( String $name, boolean $checked, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | unique name |
$checked | boolean | checked |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setIsEnabled( boolean $isEnabled, ) : n/a

#### Description

Specifies if this component is enabled and accepts user modification.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isEnabled | boolean | enabled if true |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTableRowsToHide( array $tableRowsToHide, ) : n/a

#### Description

This will hide the given table rows when the checkbox is checked.
The given IDs can be of any e.g. input element. Starting from this element the first parent "
" element will be used to show/hide.
Example:
Using "mycheckbox" will use this "tr" to hide/show.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$tableRowsToHide | array | IDs of child elements to hide |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTableRowsToShow( array $tableRowsToShow, ) : n/a

#### Description

This will show the given table rows when the checkbox is checked.
The given IDs can be of any e.g. input element. Starting from this element the first parent "
" element will be used to show/hide.
Example:
Using "mycheckbox" will use this "tr" to hide/show.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$tableRowsToShow | array | IDs of child elements to show |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTransient( boolean $transient, ) : n/a

#### Description

Specifies that the value should not be automatically saved when used in self service or server profile (default: false).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$transient | boolean | transient field |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$checked, $isEnabled, $name, $tableRowsToHide, $tableRowsToShow, $transient,

### protected $checked =

value

### protected $isEnabled = true

enabled or disabled

### protected $name =

unique name of input element

### protected $tableRowsToHide = array()

list of enclosing table rows to hide when checked

### protected $tableRowsToShow = array()

list of enclosing table rows to show when checked

### private $transient = false

indicates that this field should not automatically be saved in the self service or server profile

### htmlTableExtendedInputCheckbox

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Checkbox with descriptive label and help link.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $name, boolean $checked, String $label, String $helpID = null, boolean $labelFirst = true, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | unique name |
$checked | boolean | checked |
$label | String | descriptive label |
$helpID | String | help ID | null
$labelFirst | boolean | specifies if the label is at the beginning or at the end (optional, default beginning) | true

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$helpID, $label, $labelFirst,

### private $helpID =

help ID

### private $label =

descriptive label

### private $labelFirst =

specifies if label is printed before the checkbox

### htmlInputFileUpload

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Prints the HTML code for a file upload field.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, setIsEnabled,

### __construct( String $name, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | unique name |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setIsEnabled( boolean $isEnabled, ) : n/a

#### Description

Specifies if this component is enabled and accepts user modification.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isEnabled | boolean | enabled if true |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$isEnabled, $name,

### private $isEnabled = true

enabled or disabled

### private $name =

unique name of input element

### htmlTableExtendedInputFileUpload

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

File upload with descriptive label and help link.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $name, String $label, String $helpID = null, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | unique name |
$label | String | descriptive label |
$helpID | String | help ID | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$helpID, $label,

### private $helpID =

help ID

### private $label =

descriptive label

### htmlInputTextarea

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Prints the HTML code for a textarea.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, setIsEnabled, setIsRichEdit,

### __construct( String $name, String $value, int $colCount, int $rowCount, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | unique name |
$value | String | value |
$colCount | int | number of characters per line |
$rowCount | int | number of rows |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setIsEnabled( boolean $isEnabled, ) : n/a

#### Description

Specifies if this component is enabled and accepts user modification.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$isEnabled | boolean | enabled if true |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setIsRichEdit( boolean $richEdit, ) : n/a

#### Description

Specifies if the textarea should be displayed whith a WYSIWYG editor.
This requires that the page which displays the textarea also includes the ckeditor JS.
Rich editing is disabled by default.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$richEdit | boolean | rich edit or standard |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$colCount, $isEnabled, $name, $richEdit, $rowCount, $value,

### private $colCount =

column count

### private $isEnabled = true

enabled or disabled

### private $name =

unique name of input element

### private $richEdit = false

specifies if LAM should display this field whith a WYSIWYG editor

### private $rowCount =

row count

### private $value =

value

### htmlTableExtendedInputTextarea

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Text area with label and help link.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, setRequired,

### __construct( String $name, String $value, int $colCount, int $rowCount, String $label, String $helpID = null, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | unique name |
$value | String | value |
$colCount | int | number of characters per line |
$rowCount | int | number of rows |
$label | String | descriptive label |
$helpID | String | help ID | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setRequired( boolean $required, ) : n/a

#### Description

Specifies if this input field must be filled.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$required | boolean | required or not |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$helpID, $label, $required,

### private $helpID =

help ID

### private $label =

descriptive label

### private $required = false

required field

### htmlImage

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Prints the HTML code for an image.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $path, int $width = null, int $height = null, String $alt = ' ', ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$path | String | image location |
$width | int | image width (optional, default original size) | null
$height | int | image height (optional, default original size) | null
$alt | String | alt text (optional) | ' '

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$alt, $height, $path, $width,

### private $alt =

alt text

### private $height =

height

### private $path =

path to image

### private $width =

width

### htmlSpacer

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Adds an empty space with given width and height.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $width, String $height, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$width | String | width (e.g. 10px) |
$height | String | height (e.g. 10px) |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$height, $width,

### private $height =

height of spacer in px

### private $width =

width of spacer in px

### htmlStatusMessage

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Prints a status message (e.g. error message).
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $type, String $title, String $text = null, array $params = null, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$type | String | message type (e.g. ERROR) |
$title | String | message title |
$text | String | message (optional) | null
$params | array | additional message parameters | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$params, $text, $title, $type,

### private $params =

message parameters

### private $text =

message text

### private $title =

message title

### private $type =

message type (e.g. ERROR)

### htmlFieldset

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Generates a fieldset.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( \htmlElement $content, String $label = null, String $labelImage = null, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$content | \htmlElement | content to display inside fieldset |
$label | String | label | null
$labelImage | String | image to put before label | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$content, $label, $labelImage,

### private $content =

fieldset content

### private $label = null

descriptive label

### private $labelImage = null

label image

### htmlTitle

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Generates a title line. This is used for page titles.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $label, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$label | String | label |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$label,

### private $label = null

descriptive label

### htmlSubTitle

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Generates a subtitle line. This is used to group multiple fields.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $label, String $image = null, String $id = null, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$label | String | label |
$image | String | optional image | null
$id | String | optional ID for this element (e.g. to use for JavaScript) | null

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$id, $image, $label,

### private $id = null

optional ID for this element (e.g. to use for JavaScript)

### private $image = null

optional image

### private $label = null

descriptive label

### htmlHiddenInput

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Generates a hidden input field.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $name, String $value, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | String | input name |
$value | String | input value |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$name, $value,

### private $name = null

field name

### private $value = null

field value

### htmlLink

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Generates a link.
The link can include an optional image in front of the link text.

#### Methods

__construct, generateHTML, setOnClick, setTargetWindow, setTitle,

### __construct( String $text, String $target, String $image = null, boolean $showAsButton = false, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$text | String | label |
$target | String | target URL |
$image | String | URL of optional image | null
$showAsButton | boolean | shows this like as a button | false

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setOnClick( String $event, ) : n/a

#### Description

Sets the onClick event.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$event | String | JavaScript code |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTargetWindow( String $window, ) : n/a

#### Description

Sets the target window (e.g. _blank).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$window | String | target window (e.g. _blank) |

#### Return value

Type | Description
--- | ---
n/a | n/a

### setTitle( String $title, ) : n/a

#### Description

Sets the link title.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$title | String | title |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$image, $onClick, $showAsButton, $target, $targetWindow, $text, $title,

### private $image = null

optional image

### private $onClick = null

onClick event

### private $showAsButton = false

show as button

### private $target = null

link target

### private $targetWindow = null

target window

### private $text = null

link text

### private $title = null

title

### htmlGroup

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Groups multiple htmlElements.
This is useful if multiple elements should be included in a single table cell. The HTML code of the subelements is printed in the order they were added. No additional code is added.

#### Methods

addElement, generateHTML,

### addElement( \htmlElement $sub, ) : n/a

#### Description

Adds a subelement.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$sub | \htmlElement | subelement |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$subelements,

### private $subelements = array()

link text

### htmlHorizontalLine

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Prints a horizontal line.
This is used to build HTML code by using objects.

#### Methods

generateHTML,

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### htmlDiv

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Creates a simple DIV element.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $id, \htmlElement $content, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$id | String | unique ID |
$content | \htmlElement | inner content |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$content, $id,

### private $content = null

htmlElement that generates inner content

### private $id = null

unique ID

### htmlJavaScript

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Creates a JavaScript element.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( String $content, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$content | String | script |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$content,

### private $content = null

htmlElement that generates inner content

### htmlEqualWidth

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Sets all given elements to the same width.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( array $elements, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$elements | array | list of element IDs |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$elements,

### private $elements = array()

list of element IDs

### htmlEqualHeight

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Sets all given elements to the same height.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML,

### __construct( array $elements, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$elements | array | list of element IDs |

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$elements,

### private $elements = array()

list of element IDs

### htmlSortableList

# Properties

Extends
Implements
package
metaHTML
Abstract
No
Final
No

#### Description

Creates a list of elements that can be sorted by the user via drag'n'drop.
This is used to build HTML code by using objects.

#### Methods

__construct, generateHTML, setOnUpdate,

### __construct( array $elements, $id, String $elementWidth = '250px', ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$elements | array | list of element IDs (HTML special chars must be escaped already) |
$id | n/a |  |
$elementWidth | String | width of elements (default 250px) | '250px'

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### setOnUpdate( String $onUpdate, ) : n/a

#### Description

Sets the JS code that is executed when the element order was changed.
The code can access the variables event and ui. See JQueryUI docs for details. ui.item.data('posOrig') will contain the original position of the moved element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$onUpdate | String | JS code |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$elementWidth, $elements, $id, $onUpdate,

### private $elementWidth = ''

element width

### private $elements = array()

list of elements

### private $id = ''

HTML ID

### private $onUpdate = null

on update event

### htmlAccordion

# Properties

Extends
Implements
Abstract
No
Final
No

#### Description

Creates a list of content elements in accordion style.
HTML special characters must be escaped before providing to htmlAccordion.

#### Methods

__construct, generateHTML,

### __construct( String $id, array $elements, String $openInitial = '0', boolean $collapsible = false, ) : n/a

#### Description

Constructor.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$id | String | HTML ID |
$elements | array | list of content elements array('title' => htmlElement) |
$openInitial | String | index of element that is initially opened (default: 0), set to 'false' to close all | '0'
$collapsible | boolean | specifies if all elements may be closed at the same time (default: false, true if $openInitial is false) | false

#### Return value

Type | Description
--- | ---
n/a | n/a

### generateHTML( string $module, array $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Prints the HTML code for this element.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | array | List of meta-HTML elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

#### Properties

$collapsible, $elements, $id, $openInitial,

### private $collapsible = false

### private $elements = null

### private $id = null

### private $openInitial = '1'

Documentation was generated by phpDocumentor 2.0.1 .

# Namespaces

- global

# Packages

- Crypt_AES
  - Crypt_AES
    Pure-PHP implementation of AES.
- Crypt_DES
  - Crypt_DES
    Pure-PHP implementation of DES.
- Crypt_Hash
  - Crypt_Hash
    Pure-PHP implementations of keyed-hash message authentication codes (HMACs) and various cryptographic hashing functions.
- Crypt_RC4
  - Crypt_RC4
    Pure-PHP implementation of RC4.
- Crypt_RSA
  - Crypt_RSA
    Pure-PHP PKCS#1 compliant implementation of RSA.
- Crypt_Random
- Crypt_Rijndael
  - Crypt_Rijndael
    Pure-PHP implementation of Rijndael.
- Crypt_TerraDES
  - Crypt_TripleDES
    Pure-PHP implementation of Triple DES.
- Crypt_TripleDES
- Help
- LDAP
  - Ldap
    Ldap manages connection to LDAP and includes several helper functions.
- Math_BigInteger
  - Math_BigInteger
    Pure-PHP arbitrary precision integer arithmetic library. Supports base-2, base-10, base-16, and base-256 numbers.
- Net_SFTP
  - Net_SFTP
    Pure-PHP implementations of SFTP.
- Net_SSH1
  - Net_SSH1
    Pure-PHP implementation of SSHv1.
- Net_SSH2
  - Net_SSH2
    Pure-PHP implementation of SSHv2.
- PDF
  - UFPDF
    Main UFPDF class for creating Unicode PDF documents
  - lamPDF
    Creates a LAM information page in PDF format.
  - xmlParser
    Simple XML parser.
- PHP_Compat
- configuration
  - LAMCfgMain
    This class manages config.cfg.
  - LAMConfig
    This class manages .conf files.
- horde.cipher
  - Horde_Cipher_blowfish
- lam
  - smbHash
    Calculates NT and LM hashes.
- lib
  - AttributeType
    Represents an LDAP AttributeType
  - MatchingRule
    Represents an LDAP MatchingRule
  - MatchingRuleUse
    Represents an LDAP schema matchingRuleUse entry
  - ObjectClass
    Represents an LDAP objectClass
  - ObjectClassAttribute
    A simple class for representing AttributeTypes used only by the ObjectClass class.
  - SchemaItem
    Generic parent class for all schema items. A schema item is an ObjectClass, an AttributeBype, a MatchingRule, or a Syntax.
  - Syntax
    Represents an LDAP Syntax
- lists
  - lamAsteriskExtList
    Generates the list view.
  - lamBooleanListOption
    Boolean option for list configuration.
  - lamDHCPList
    Generates the list view.
  - lamGroupList
    Generates the list view.
  - lamHostList
    Generates the list view.
  - lamList
    Generates the list view.
  - lamListOption
    Represents a list configuration option.
  - lamListTool
    Represents a tool which can be included in the account lists.
  - lamMailAliasList
    Generates the list view.
  - lamNetgroupList
    Generates the list view.
  - lamSelectListOption
    Boolean option for list configuration.
  - lamSmbDomainList
    Generates the list view.
  - lamUserList
    Generates the list view.
- main
- metaHTML
  - htmlAccountPageButton
    Prints a button for the account pages.
  - htmlButton
    Simple button.
  - htmlDiv
    Creates a simple DIV element.
  - htmlElement
    Represents a HTML element.
  - htmlEqualHeight
    Sets all given elements to the same height.
  - htmlEqualWidth
    Sets all given elements to the same width.
  - htmlFieldset
    Generates a fieldset.
  - htmlGroup
    Groups multiple htmlElements.
  - htmlHelpLink
    Renders a help link.
  - htmlHiddenInput
    Generates a hidden input field.
  - htmlHorizontalLine
    Prints a horizontal line.
  - htmlImage
    Prints the HTML code for an image.
  - htmlInputCheckbox
    Prints the HTML code for a checkbox.
  - htmlInputField
    A standard input field.
  - htmlInputFileUpload
    Prints the HTML code for a file upload field.
  - htmlInputTextarea
    Prints the HTML code for a textarea.
  - htmlJavaScript
    Creates a JavaScript element.
  - htmlLink
    Generates a link.
  - htmlOutputText
    Prints the text and escapes contained HTML code by default.
  - htmlRadio
    Represents a radio selection.
  - htmlSelect
    Represents a select box.
  - htmlSortableList
    Creates a list of elements that can be sorted by the user via drag'n'drop.
  - htmlSpacer
    Adds an empty space with given width and height.
  - htmlStatusMessage
    Prints a status message (e.g. error message).
  - htmlSubTitle
    Generates a subtitle line. This is used to group multiple fields.
  - htmlTable
    Structures elements using a table.
  - htmlTableExtendedInputCheckbox
    Checkbox with descriptive label and help link.
  - htmlTableExtendedInputField
    An extended input field that combines label, input field and help.
  - htmlTableExtendedInputFileUpload
    File upload with descriptive label and help link.
  - htmlTableExtendedInputTextarea
    Text area with label and help link.
  - htmlTableExtendedRadio
    Radio list with descriptive label and help link.
  - htmlTableExtendedSelect
    Select with label and help link.
  - htmlTableRow
    A row inside a htmlTable.
  - htmlTitle
    Generates a title line. This is used for page titles.
- modules
  - account
    Manages the object class "account" for users and hosts.
  - accountContainer
    This class includes all modules and attributes of an account.
  - asteriskAccount
    Manages the Asterisk extension of user accounts.
  - asteriskExtension
    Manages Asterisk extensions.
  - asteriskVoicemail
    Manages the Asterisk extension of user accounts.
  - authorizedServiceObject
    Provides Authorized Service for accounts.
  - baseModule
    Parent class of all account modules.
  - ddns
    Manages DDNS entries.
  - dhcp_settings
    Manages DHCP entries.
  - eduPerson
    Manages the eduPerson extension for user accounts.
  - fixed_ip
    Manages DHCP host entries.
  - freeRadius
    Manages FreeRadius accounts.
  - generalInformation
    Shows general information like the creation time of an account.
  - hostObject
    Manages the hosts to which a user may login.
  - ieee802device
    Provides MAC addresses for hosts.
  - imapAccess
    Manages mailboxes on an IMAP server.
  - inetLocalMailRecipient
    Provides mail routing for users.
  - inetOrgPerson
    This module manages LDAP attributes of the object class inetOrgPerson (e.g. name and address).
  - kolabGroup
    Manages Kolab group accounts.
  - kolabUser
    Manages Kolab user accounts.
  - ldapPublicKey
    Manages SSH public keys.
  - nisMailAlias
    Provides NIS mail alias management.
  - nisnetgroup
    Manages entries based on the object class nisNetgroup.
  - passwordService
    This interface needs to be implemented by all account modules which manage passwords.
  - posixAccount
    Manages the object class "posixAccount" for users and hosts.
  - posixGroup
    Manages the object class "posixGroup" for groups.
  - puppetClient
    Manages Puppet configuration options.
  - quota
    Manages quotas for users and groups.
  - range
    Manages DHCP ranges for DHCP server.
  - samba3domain
    Represents a Samba 3 domain entry
  - sambaDomain
    Manages Samba 3 domain entries.
  - sambaGroupMapping
    Manages the object class "sambaGroupMapping" for groups.
  - sambaMungedDial
    Manages terminal server settings for Samba 3.
  - sambaSamAccount
    Manages the object class "sambaSamAccount" for users and hosts.
  - shadowAccount
    Manages the object class "shadowAccount" for users.
  - smbHash
    Calculates NT and LM hashes.
  - systemQuotas
    Manages user quotas with the object class systemQuotas.
  - windowsGroup
    Manages Windows AD (e.g. Samba 4) groups.
  - windowsHost
    Manages Windows AD (e.g. Samba 4) hosts.
  - windowsPosixGroup
    Manages Unix groups in Windows LDAP schema.
  - windowsUser
    Manages Windows AD (e.g. Samba 4) users.
- phpLDAPadmin
- profiles
- selfService
  - selfServiceProfile
    Includes all settings of a self service profile.
- tools
  - LAMSubTool
    Represents a subtool.
  - LAMTool
    Represents a tool.
  - toolFileUpload
    File upload
  - toolOUEditor
    OU editor
  - toolPDFEditor
    PDF editor
  - toolProfileEditor
    Profile editor
  - toolSchemaBrowser
    Schema browser
  - toolServerInformation
    Server information
  - toolTests
    Tests page
- types
  - asteriskExt
    The account type for Asterisk extensions.
  - baseType
    This is the parent class of all account types.
  - dhcp
    The account type for DHCP
  - group
    The account type for group accounts (e.g. Unix and Samba).
  - host
    The account type for host accounts (e.g. Samba).
  - mailAlias
    The account type for mail aliases.
  - netgroup
    The account type for NIS netgroups.
  - smbDomain
    The account type for Samba domains.
  - user
    The account type for user accounts (e.g. Unix, Samba and Kolab).